Index: trunk/MagicSoft/Mars/mjobs/MJCalibration.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJCalibration.cc	(revision 4238)
+++ trunk/MagicSoft/Mars/mjobs/MJCalibration.cc	(revision 4243)
@@ -717,4 +717,91 @@
       // a colour, but which have been found out by other means
       //
+      if (filenames.Contains("_26924_"))
+        if (fColor == MCalibrationCam::kNONE)
+          {
+            *fLog << "Found colour: kGREEN  in " << filenames << endl;
+            fColor = MCalibrationCam::kGREEN;
+          }
+        else if (fColor != MCalibrationCam::kGREEN)
+          {
+            *fLog << err << "Different colour found in " << filenames << "... abort" << endl;
+            return kFALSE;
+          }
+
+
+      if (filenames.Contains("_26568_"))
+        if (fColor == MCalibrationCam::kNONE)
+          {
+            *fLog << "Found colour: kGREEN  in " << filenames << endl;
+            fColor = MCalibrationCam::kGREEN;
+          }
+        else if (fColor != MCalibrationCam::kGREEN)
+          {
+            *fLog << err << "Different colour found in " << filenames << "... abort" << endl;
+            return kFALSE;
+          }
+
+      if (filenames.Contains("_26412_"))
+        if (fColor == MCalibrationCam::kNONE)
+          {
+            *fLog << "Found colour: kGREEN  in " << filenames << endl;
+            fColor = MCalibrationCam::kGREEN;
+          }
+        else if (fColor != MCalibrationCam::kGREEN)
+          {
+            *fLog << err << "Different colour found in " << filenames << "... abort" << endl;
+            return kFALSE;
+          }
+
+
+      if (filenames.Contains("_26409_"))
+        if (fColor == MCalibrationCam::kNONE)
+          {
+            *fLog << "Found colour: kGREEN  in " << filenames << endl;
+            fColor = MCalibrationCam::kGREEN;
+          }
+        else if (fColor != MCalibrationCam::kGREEN)
+          {
+            *fLog << err << "Different colour found in " << filenames << "... abort" << endl;
+            return kFALSE;
+          }
+
+      if (filenames.Contains("_26408_"))
+        if (fColor == MCalibrationCam::kNONE)
+          {
+            *fLog << "Found colour: kGREEN  in " << filenames << endl;
+            fColor = MCalibrationCam::kGREEN;
+          }
+        else if (fColor != MCalibrationCam::kGREEN)
+          {
+            *fLog << err << "Different colour found in " << filenames << "... abort" << endl;
+            return kFALSE;
+          }
+
+
+      if (filenames.Contains("_26402_"))
+        if (fColor == MCalibrationCam::kNONE)
+          {
+            *fLog << "Found colour: kBLUE  in " << filenames << endl;
+            fColor = MCalibrationCam::kBLUE;
+          }
+        else if (fColor != MCalibrationCam::kBLUE)
+          {
+            *fLog << err << "Different colour found in " << filenames << "... abort" << endl;
+            return kFALSE;
+          }
+
+      if (filenames.Contains("_20661_"))
+        if (fColor == MCalibrationCam::kNONE)
+          {
+            *fLog << "Found colour: kGREEN  in " << filenames << endl;
+            fColor = MCalibrationCam::kGREEN;
+          }
+        else if (fColor != MCalibrationCam::kGREEN)
+          {
+            *fLog << err << "Different colour found in " << filenames << "... abort" << endl;
+            return kFALSE;
+          }
+
       if (filenames.Contains("_20660_"))
         if (fColor == MCalibrationCam::kNONE)
@@ -729,76 +816,4 @@
           }
 
-      if (filenames.Contains("_20661_"))
-        if (fColor == MCalibrationCam::kNONE)
-          {
-            *fLog << "Found colour: kGREEN  in " << filenames << endl;
-            fColor = MCalibrationCam::kGREEN;
-          }
-        else if (fColor != MCalibrationCam::kGREEN)
-          {
-            *fLog << err << "Different colour found in " << filenames << "... abort" << endl;
-            return kFALSE;
-          }
-
-      if (filenames.Contains("_26402_"))
-        if (fColor == MCalibrationCam::kNONE)
-          {
-            *fLog << "Found colour: kBLUE  in " << filenames << endl;
-            fColor = MCalibrationCam::kBLUE;
-          }
-        else if (fColor != MCalibrationCam::kBLUE)
-          {
-            *fLog << err << "Different colour found in " << filenames << "... abort" << endl;
-            return kFALSE;
-          }
-
-      if (filenames.Contains("_26408_"))
-        if (fColor == MCalibrationCam::kNONE)
-          {
-            *fLog << "Found colour: kGREEN  in " << filenames << endl;
-            fColor = MCalibrationCam::kGREEN;
-          }
-        else if (fColor != MCalibrationCam::kGREEN)
-          {
-            *fLog << err << "Different colour found in " << filenames << "... abort" << endl;
-            return kFALSE;
-          }
-
-      if (filenames.Contains("_26409_"))
-        if (fColor == MCalibrationCam::kNONE)
-          {
-            *fLog << "Found colour: kGREEN  in " << filenames << endl;
-            fColor = MCalibrationCam::kGREEN;
-          }
-        else if (fColor != MCalibrationCam::kGREEN)
-          {
-            *fLog << err << "Different colour found in " << filenames << "... abort" << endl;
-            return kFALSE;
-          }
-
-      if (filenames.Contains("_26412_"))
-        if (fColor == MCalibrationCam::kNONE)
-          {
-            *fLog << "Found colour: kGREEN  in " << filenames << endl;
-            fColor = MCalibrationCam::kGREEN;
-          }
-        else if (fColor != MCalibrationCam::kGREEN)
-          {
-            *fLog << err << "Different colour found in " << filenames << "... abort" << endl;
-            return kFALSE;
-          }
-
-
-      if (filenames.Contains("_26568_"))
-        if (fColor == MCalibrationCam::kNONE)
-          {
-            *fLog << "Found colour: kGREEN  in " << filenames << endl;
-            fColor = MCalibrationCam::kGREEN;
-          }
-        else if (fColor != MCalibrationCam::kGREEN)
-          {
-            *fLog << err << "Different colour found in " << filenames << "... abort" << endl;
-            return kFALSE;
-          }
       //
       // Here start the runs where the shifter put 